<script>
  import { max } from "d3-array";
  import { scaleLinear } from "d3-scale";
  import { area } from "d3-shape";

  // Properties
  export let data;
  export let week;
  let maxValue = 0;
  export let dX = 200;
  export let dY = 200;
  export let dRot = -45;
  export let scaleY = 1;
  const GAS = "GAS";
  const ELEC = "ELECTRICITY";
  let coordsGas = [];
  let coordsElec = [];
  let hoursOffset = 0;

  // Dimensions
  const width = 500;
  const height = 600;

  const leafHeight = 40;
  const leafWidth = 150;

  // Scales
  const xScale = scaleLinear().domain([0, 7*24]).range([0, leafWidth]);
  $: yScale = scaleLinear().domain([0, maxValue]).range([0, leafHeight]);
  
  // area  
  $: myGraph = area()
      .x(d => d.x)
      .y0(d => d.y0)
      .y1(d => d.y1); 

  $: if (data) {
    let maxGas = max(data, d => d.total_gas);
    let maxElec = max(data, d => d.total_electrity);
    let maxValue = maxGas > maxElec ? maxGas : maxElec;
    hoursOffset = (week - 1) * 7 * 24;
    coordsGas = getCoords(GAS, -1, maxValue);
    coordsElec = getCoords(ELEC, 1, maxValue);
  }

  $: if (dRot) {
    console.log("X, Y, Rot: ", dX, dY, dRot);
  }

  function getCoords(energyType, sign, maxValue) {
    yScale = scaleLinear().domain([0, maxValue]).range([0, leafHeight]);
    if (!data) return data;
    let weekCoords = data.map((d) => {
        let x_coord = xScale(((d.day - 1) * 24 + d.hour) - hoursOffset);
        let y_value = energyType == GAS ? yScale(d.total_gas) : yScale(d.total_electrity);
        y_value = leafHeight + (sign * y_value);
        return { x: x_coord, y0: leafHeight, y1: y_value };
      });
    // console.log(weekCoords);
    return weekCoords;
  }

</script>

  <g transform="translate({dX}, {dY}) rotate({dRot}, 0, 0) scale(1, {scaleY}) ">
      <path fill="blue" fill-opacity="0.5" stroke="blue" stroke-width="1" d="{myGraph(coordsGas)}"/>
      <path fill="orange" fill-opacity="0.5" stroke="orange" stroke-width="1" d="{myGraph(coordsElec)}"/>
  </g>

